<script setup>
// imports
import ProductCategory from '@/components/products/ProductCategory.vue'
import ProductBrand from '@/components/products/ProductBrand.vue'
import ProductRating from '@/components/products/ProductRating.vue'
import { ref } from 'vue'
import {api , error_handler} from "@/core/services/api.service"
import DotsLoadingIcon from "@/assets/svg/DotsLoadingIcon.vue"
import {toast} from "vue3-toastify";

// props
const props = defineProps({
  product: { type: Object }
})

// data
const deletePopUp = ref(false)
const deletingProduct = ref(false)

// methods
const deleteProductHandler = async () => {
  deletingProduct.value = true
  await api.delete(`/products/${props.product.id}`).then(res => {
    if(res.data.isDeleted){
      toast('The product has been successfully deleted' , {type : 'success'})
    }
  }).catch(error => {
    error_handler(error)
  }).finally(() => {
    deletePopUp.value = false
    deletingProduct.value = false
  })
}
</script>
<template>
  <router-link
    :to="`/products/${props.product?.id}`"
    title="test"
    class="group bg-background-secondary-light dark:bg-background-secondary-dark rounded-md flex flex-col gap-5 p-5"
  >
    <div class="aspect-[16/9] overflow-hidden rounded-sm relative">
      <router-link
        v-if="!deletePopUp"
        :to="`/products/${props.product.id}/edit`"
        title="Edit post"
        class="w-8 h-8 flex items-center justify-center bg-background-primary-light dark:bg-background-primary-dark absolute max-lg:top-4 lg:-top-8 group-hover:top-4 left-4 z-[1] rounded-full transition-all"
        ><i class="flaticon-solarpen2bold"></i
      ></router-link>
      <button
        v-if="!deletePopUp"
        @click.prevent.stop="deletePopUp = true"
        title="Delete post"
        class="w-8 h-8 flex items-center justify-center bg-background-primary-light dark:bg-background-primary-dark absolute max-lg:top-4 lg:-top-8 group-hover:top-4 left-14 z-[1] rounded-full delay-100 transition-all"
      >
        <i class="flaticon-solartrashbin2bold"></i>
      </button>

      <div
        @click.prevent.stop
        :class="deletePopUp && '!top-4 !opacity-100 !visible'"
        class="absolute left-4 right-4 -top-14 opacity-0 invisible transition-all rounded-sm p-4 z-[2] bg-rose-500 max-h-[56px] flex items-center justify-between gap-3"
      >
        <span class="!text-white">Are you sure?</span>
        <DotsLoadingIcon class="!text-white" v-if="deletingProduct" />
        <div v-else class="flex items-center gap-2">
          <button @click.prevent.stop="deleteProductHandler" class="bg-white !text-black rounded-full text-xs px-2 py-0.5">Yes</button>
          <button @click.prevent.stop="deletePopUp = false" class="bg-white !text-black rounded-full text-xs px-2 py-0.5">No</button>
        </div>
      </div>

      <img
        :src="product?.thumbnail"
        :alt="product?.title"
        :title="product?.title"
        class="w-full h-full object-cover transition-transform group-hover:scale-150 duration-1000"
      />
    </div>
    <div>
      <h3 class="text-20 font-semibold truncate">{{ product?.title }}</h3>
      <p class="text-14 text-text-secondary-light dark:text-text-secondary-dark truncate">
        {{ product?.description }}
      </p>
    </div>
    <div class="flex flex-col gap-1">
      <ProductRating :rate="product?.rating" />
      <div class="flex gap-2 md:flex-col 2xl:flex-row 2xl:items-center lg:gap-1 2xl:gap-4">
        <ProductCategory :title="product?.category" />
        <ProductBrand :title="product?.brand" />
      </div>
    </div>
  </router-link>
</template>
<style scoped></style>
